<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="装置名称" prop="plants">
      <el-select v-model="plantIds"  size="small"  @change="handleCommand" multiple collapse-tags :placeholder="$t('请选择') + $t('装置')">
        <el-checkbox v-model="checked" @change="selectAll"> ALL</el-checkbox>
        <el-option
          v-for="item in plantOptions"
          :key="item.name"
          :label="item.name"
          :value="item.name">
        </el-option>
      </el-select>
      </el-form-item>
      <el-form-item label="周排查日期" prop="checkDate">
        <el-date-picker
          v-model="chooseDate"
          @change="handleQuery"
          type="daterange"
          style="width: 508px"
          align="right"
          unlink-panels
          :range-separator="$t('至')"
          :start-placeholder="$t('开始日期')"
          :end-placeholder="$t('结束日期')"
          value-format="yyyy-MM-dd"
          :picker-options="pickerOptions">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="周" prop="weekNo">
        <el-input
          v-model="queryParams.weekNo"
          placeholder="请输入周"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['safecheck:personweekcheck:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['safecheck:personweekcheck:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['safecheck:personweekcheck:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['safecheck:personweekcheck:export']"
        >导出</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="multiple"
          @click="handleBatchConfirm"
          v-hasPermi="['safecheck:weekcheck:edit']"
        >批量锁定</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-edit"
          size="mini"
          :disabled="multiple"
          @click="handleBatchCancel"
          v-hasPermi="['safecheck:weekcheck:edit']"
        >取消锁定</el-button>
      </el-col>
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <u-table v-loading="loading" :data="personweekcheckList" @selection-change="handleSelectionChange"
             use-virtual
             showBodyOverflow="title"
             :row-height="60"
             :height="clientHeight" border>
      <u-table-column type="selection" width="55" align="center" />
      <u-table-column label="装置名称" align="center" prop="plantCode" :show-overflow-tooltip="true"/>
      <u-table-column label="周排查日期" align="center" prop="checkDate" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.checkDate, '{y}-{m}-{d}') }}</span>
        </template>
      </u-table-column>
      <u-table-column label="安全员" align="center" prop="checkerName" width="120">
        <template slot-scope="scope">
          <span v-if="scope.row.agentId">{{ scope.row.checkerName}} 代 {{ scope.row.agentName}}</span>
          <span v-else>{{ scope.row.checkerName}}</span>
        </template>
      </u-table-column>      <u-table-column label="周" align="center" prop="weekNo" :show-overflow-tooltip="true"/>
<!--      <u-table-column label="状态" align="center" prop="isConfirm" :show-overflow-tooltip="true" :formatter="isConfirmFormat"/>-->
      <u-table-column label="上周安全风险隐患问题整改核实情况" align="center" prop="lastWeekRisk" :show-overflow-tooltip="true"/>
      <u-table-column label="本周主要安全风险隐患和整改情况" align="center" prop="thisWeekRisk" :show-overflow-tooltip="true"/>
      <u-table-column label="本周安全管理情况评价" align="center" prop="safeCondition" :show-overflow-tooltip="true"/>
      <u-table-column label="下周工作重点" align="center" prop="nextWeekWork" :show-overflow-tooltip="true"/>
      <u-table-column label="操作" align="center" fixed="right" width="120" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            v-if="scope.row.isConfirm == 0"
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['safecheck:personweekcheck:edit']"
          >修改</el-button>
          <el-button
            v-if="scope.row.isConfirm == 0"
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['safecheck:personweekcheck:remove']"
          >删除</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-document"
            @click="handleDoc(scope.row)"
          >附件
          </el-button>
        </template>
      </u-table-column>

    </u-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :page-sizes="[20,100,300,500]"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改每周个人安全检查对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="900px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="150px">
        <el-form-item label="装置名称" prop="plantCode">
          <el-select v-model="form.plantCode" :placeholder="$t('请选择')+ $t('装置')" filterable clearable size="small"
          >
            <el-option
              v-for="dict in plantOptions"
              :key="dict.name"
              :label="dict.name"
              :value="dict.name"
            />
          </el-select>
        </el-form-item>
        <el-row>
          <el-col :span="12">
            <el-form-item  label-width="150px" label="周排查日期" prop="checkDate">
              <el-date-picker clearable size="small" style="width: 200px" @change="calculateWeekNumber"
                              v-model="form.checkDate"
                              type="date"
                              value-format="yyyy-MM-dd"
                              placeholder="选择周排查日期">
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label-width="150px" label="周" prop="weekNo">
              <el-input v-model="form.weekNo" placeholder="请输入周" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-form-item label="上周安全风险隐患问题整改核实情况" prop="lastWeekRisk">
          <el-input v-model="form.lastWeekRisk" :autosize="{ minRows: 2, maxRows: 9}" type="textarea" placeholder="请输入上周安全风险隐患问题整改核实情况" />
        </el-form-item>
        <el-form-item label="本周主要安全风险隐患和整改情况" prop="thisWeekRisk">
          <el-input v-model="form.thisWeekRisk" :autosize="{ minRows: 2, maxRows: 9}" type="textarea" placeholder="请输入本周主要安全风险隐患和整改情况" />
        </el-form-item>
        <el-form-item label="本周安全管理情况评价" prop="safeCondition">
          <el-radio-group v-model="form.safeCondition">
            <el-radio label="安全风险可控，无较大（质量）安全风险隐患">安全风险可控，无较大（质量）安全风险隐患</el-radio>
            <el-radio label="存在安全风险隐患，需尽快采取防范措施">存在安全风险隐患，需尽快采取防范措施</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="下周工作重点" prop="nextWeekWork">
          <el-input v-model="form.nextWeekWork" :autosize="{ minRows: 2, maxRows: 9}" type="textarea" placeholder="请输入下周工作重点" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
      <!-- 用户导入对话框 -->
      <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
          <el-upload
                  ref="upload"
                  :limit="1"
                  accept=".xlsx, .xls"
                  :headers="upload.headers"
                  :action="upload.url + '?updateSupport=' + upload.updateSupport"
                  :disabled="upload.isUploading"
                  :on-progress="handleFileUploadProgress"
                  :on-success="handleFileSuccess"
                  :auto-upload="false"
                  drag
          >
              <i class="el-icon-upload"></i>
              <div class="el-upload__text">
                  将文件拖到此处，或
                  <em>点击上传</em>
              </div>
              <div class="el-upload__tip" slot="tip">
                  <el-checkbox v-model="upload.updateSupport" />是否更新已经存在的用户数据
                  <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
              </div>
              <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
          </el-upload>
          <div slot="footer" class="dialog-footer">
              <el-button type="primary" @click="submitFileForm">确 定</el-button>
              <el-button @click="upload.open = false">取 消</el-button>
          </div>
      </el-dialog>
    <Attachment ref="childRef"></Attachment>
  </div>
</template>

<script>
import { batchCancel, batchConfirm,listPersonweekcheck, getPersonweekcheck, delPersonweekcheck, addPersonweekcheck, updatePersonweekcheck, exportPersonweekcheck, importTemplate} from "@/api/sems/safecheck/personweekcheck";
import { treeselect } from "@/api/system/dept";
import { getToken } from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {mylistPlant} from "@/api/system/plant";
import Attachment from '@/views/components/file/attachment.vue'

export default {
  name: "Personweekcheck",
  components: { Treeselect,Attachment },
  data() {
    return {
      // 遮罩层
      loading: true,
      checked:true,
      // 选中数组
      ids: [],
      dataListSelections: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 每周个人安全检查表格数据
      personweekcheckList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      plantOptions: [],
      plantIds: [],
      clientHeight:300,
      // 是否显示弹出层
      open: false,
        // 用户导入参数
        upload: {
            // 是否显示弹出层（用户导入）
            open: false,
            // 弹出层标题（用户导入）
            title: "",
            // 是否禁用上传
            isUploading: false,
            // 是否更新已经存在的用户数据
            updateSupport: 0,
            // 设置上传的请求头部
            headers: { Authorization: "Bearer " + getToken() },
            // 上传的地址
            url: process.env.VUE_APP_BASE_API + "/safecheck/personweekcheck/importData"
        },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 500,
        plantCode: null,
        checkDate: null,
        weekNo: null,
        lastWeekRisk: null,
        thisWeekRisk: null,
        safeCondition: null,
        nextWeekWork: null
      },
      //日期快速选择
      pickerOptions: {
        shortcuts: [{
          text: this.$t('最近一周'),
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
            picker.$emit('pick', [start, end]);
          }
        }, {
          text: this.$t('最近一个月'),
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
            picker.$emit('pick', [start, end]);
          }
        }, {
          text: this.$t('最近三个月'),
          onClick(picker) {
            const end = new Date();
            const start = new Date();
            start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
            picker.$emit('pick', [start, end]);
          }
        }]
      },
      //日期选择器
      chooseDate: [],
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  watch: {
        // 根据名称筛选部门树
        deptName(val) {
            this.$refs.tree.filter(val);
        }
   },
  created() {
      //设置表格高度对应屏幕高度
      this.$nextTick(() => {
          this.clientHeight = document.body.clientHeight -250
      })
    this.getList();
    let plantParams = {
      pType: 1
    }
    mylistPlant(plantParams).then(response => {
      this.plantOptions = response.data;
    });
    this.getTreeselect();
  },
  methods: {
    /** 查询每周个人安全检查列表 */
    getList() {
      this.loading = true;
      listPersonweekcheck(this.queryParams).then(response => {
        this.personweekcheckList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
     /** 查询部门下拉树结构 */
     getTreeselect() {
          treeselect().then(response => {
              this.deptOptions = response.data;
          });
     },
    // 字典翻译
    isConfirmFormat(row, column) {
      let type = 'info';
      if (row.isConfirm == 0) {
        let s = '未锁定'
        return <el-tag type={type}>{s}</el-tag>;
      }
      if (row.isConfirm == 1) {
        let s = '已锁定'
        type = 'success';
        return <el-tag type={type}>{s}</el-tag>;
      }
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        plantCode: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        checkDate: null,
        checkerId: null,
        weekNo: null,
        lastWeekRisk: '无',
        thisWeekRisk: '无',
        safeCondition: '安全风险可控，无较大（质量）安全风险隐患',
        nextWeekWork: '无'
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      if (this.chooseDate == null) {
        this.chooseDate = []
      }
      this.queryParams.startDate = this.chooseDate[0]
      this.queryParams.endDate = this.chooseDate[1]
      this.queryParams.plants = this.plantIds.join(',')
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.chooseDate = "";
      this.plantIds = [];
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
      this.dataListSelections = selection
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加每周个人安全检查";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      var rows = this.dataListSelections.map(item => {
        return item
      })
      for (let i = 0; i < rows.length; i++) {
        if (rows[i].isConfirm != 0) {
          this.$alert("已锁定，无法修改", this.$t('提示'), {
            type: 'warning'
          })
          return
        }
      }
      getPersonweekcheck(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改每周个人安全检查";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updatePersonweekcheck(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addPersonweekcheck(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    calculateWeekNumber() {
      console.log(this.form.checkDate)
      if (this.form.checkDate) {
        const date = new Date(this.form.checkDate);
        const yearStart = new Date(date.getFullYear(), 0, 1);
        const days = Math.floor((date - yearStart) / (24 * 60 * 60 * 1000));
        const weekNumber = Math.ceil((days + yearStart.getDay() + 1) / 7);
        this.form.weekNo = weekNumber;
      }
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      var rows = this.dataListSelections.map(item => {
        return item
      })
      for (let i = 0; i < rows.length; i++) {
        if (rows[i].isConfirm != 0) {
          this.$alert("已锁定，无法删除", this.$t('提示'), {
            type: 'warning'
          })
          return
        }
      }
      this.$confirm('是否确认删除?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delPersonweekcheck(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有每周个人安全检查数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportPersonweekcheck(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    },
      /** 导入按钮操作 */
      handleImport() {
          this.upload.title = "用户导入";
          this.upload.open = true;
      },
      /** 下载模板操作 */
      importTemplate() {
          importTemplate().then(response => {
              this.download(response.msg);
          });
      },
      // 文件上传中处理
      handleFileUploadProgress(event, file, fileList) {
          this.upload.isUploading = true;
      },
      // 文件上传成功处理
      handleFileSuccess(response, file, fileList) {
          this.upload.open = false;
          this.upload.isUploading = false;
          this.$refs.upload.clearFiles();
          this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
          this.getList();
      },
      // 提交上传文件
      submitFileForm() {
          this.$refs.upload.submit();
      },
    /** 报告附件按钮操作 */
    handleDoc(row) {
      // 通过ref引用子组件
      const child = this.$refs.childRef;
      // 调用子组件的方法并传递参数
      child.handleDoc(row , 'personweekcheck');
    },
    /** 批量按钮操作 */
    handleBatchConfirm(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否锁定?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function() {
        return batchConfirm(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("操作成功");
      })
    },
    /** 批量按钮操作 */
    handleBatchCancel(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否取消锁定?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function() {
        return batchCancel(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("操作成功");
      })
    },
    selectAll() {
      this.plantIds = []
      if (this.checked) {
        this.plantOptions.map((item) => {
          this.plantIds.push(item.name)
        })
      } else {
        this.plantIds = []
      }
      if (this.plantIds.length == 0) {
        this.plantIds = ['']
      }
    },
    handleCommand(val) {
      if (this.plantIds.length == 0) {
        this.plantIds = ['']
      }
      val.forEach((item,index)=>{
        if(item===''){
          val.splice(index,1)
        }
      })
      if (val.length === this.plantOptions.length) {
        this.checked = true
      } else {
        this.checked = false
      }
    },
  }
};
</script>
